/*
Copyright 2014 Paul Soulsby www.soulsbysynths.com
    This file is part of Atmegatron.

    Atmegadrum is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Atmegadrum is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Atmegadrum.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <EEPROM.h>

byte mem_loadonbeat = 255;

void Memory_Let_LoadOnBeat(byte newval){
	mem_loadonbeat = newval;
}
byte Memory_Get_LoadOnBeat(){
	return mem_loadonbeat;
}

void Memory_Save(byte patchnum){
  byte i, lsb, msb;
  int tmp,addr;
  
  //cli();
  
  addr = patchnum * MEM_PATCHSIZE;
 
  //sadly only enough room for 16 patterns :(
  for (i=0;i<16;i++){
    tmp =  Seq_Get_PatternRaw(i);
    lsb = ((tmp >> 0) & 0xFF);
    msb = ((tmp >> 8) & 0xFF);
		EEPROM.write(addr, lsb);
    EEPROM.write(addr + 1, msb);
		addr += 2;
  }

  //sei();
  
}
void Memory_Load(byte patchnum){
  byte i, lsb, msb;
  int addr, tmp;
  
  //cli();
  
  addr = patchnum * MEM_PATCHSIZE;
  //16 patterns
  for (i=0;i<16;i++){
    lsb = EEPROM.read(addr);
    msb = EEPROM.read(addr + 1);
		tmp = ((lsb << 0) & 0xFF) + ((msb << 8) & 0xFF00);
		Seq_Let_PatternRaw(i, tmp);
		addr += 2;
  }
  
  //sei();

}
