/*
Copyright 2014 Paul Soulsby www.soulsbysynths.com
    This file is part of Atmegatron.

    Atmegadrum is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Atmegadrum is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Atmegadrum.  If not, see <http://www.gnu.org/licenses/>.
*/
#define PITCH_LFOMAX 1.386294361119891f  //ln(4) //0.693147180559945f   //

//local
byte pitch_lfolookup[256];
float pitch_lfoamtf = 0;
unsigned long pitch_lastfreq_calc = 220;
boolean pitch_changed = true;
//
////lets and gets

unsigned int pitch_curfreq = 8000;  //can't be 0


byte pitch_lfoamt = 0;

unsigned long pitch_freq_calc = 8000;  //like with the filter, this is just to stop curfreq changing when doing oc1a calc
//
////lets and gets
//
void Pitch_Let_CurFreq(unsigned int newfreq){
  pitch_curfreq = newfreq;
}
unsigned int Pitch_Get_CurFreq(){   //you should only ever get this.  Let Nextfreq for new note.
  return pitch_curfreq;
}

unsigned long Pitch_Get_FreqCalc(){
  return pitch_freq_calc;
}
boolean Pitch_Get_PitchChanged(){
  return pitch_changed;
}

////************PITCH PROCESS****************
void Pitch_Process(){
  unsigned long p;

  //set to curfreq
  p = (unsigned long)pitch_curfreq;
  //mult by LFO
  if (pitch_lfoamt>0){
    p = p * (Pitch_Get_LFOGain() + 1) >> 6UL;  // this value (7) is tied in with unity gain=128 = *1, 7=128, 6=64, 5=32
  }
	
  pitch_freq_calc = p;

  if (pitch_freq_calc!=pitch_lastfreq_calc){
    pitch_changed = true;
    pitch_lastfreq_calc = pitch_freq_calc;
  }
  else{
    pitch_changed = false;
  }
}

//************Pitch LFO***************
void Pitch_Let_LFOAmt(byte newamt){
  if (newamt!=pitch_lfoamt){
    pitch_lfoamt = newamt;
    pitch_lfoamtf = (float)pitch_lfoamt * PITCH_LFOMAX / 255;
    memset(pitch_lfolookup,0,sizeof(pitch_lfolookup));
  }
}
byte Pitch_Get_LFOAmt(){
  return pitch_lfoamt;
}
byte Pitch_Get_LFOGain(){
  byte index;
  float f, g;
  index = LFO_Get_Level() + 127;  //take away negative offset
  if (pitch_lfolookup[index]==0){
      f = (float)LFO_Get_Level() / 127;   //turn into floating point
      g = round(exp(f * pitch_lfoamtf) * 64 - 1);   
      pitch_lfolookup[index] = (byte)g;
  }
  return pitch_lfolookup[index];
}
